package skladiste;
import predmeti.*;

public class Skladiste {
	private double VMax;
	private double Vs=0;
	private Elem prvi,posl;
	
	public Skladiste(double V){VMax=V;}
	//public Skladiste(Predmet p){prvi=new Elem(p);}
	
	public synchronized void dodaj(Predmet p)throws InterruptedException{
		while(VMax<Vs+p.V())wait();
		Elem novi = new Elem(p);
		Elem tek=prvi;
		while(tek!=null){
			tek=tek.sled;
			}
			if(prvi==null)prvi=novi;
			else posl.sled=novi;
			posl=novi;
			Vs+=p.V();
			notifyAll();
	}
	public boolean nema(char c){
		if(prvi==null)return true;
		for(Elem tek=prvi;tek!=null;tek=tek.sled)if(tek.p.vrsta()==c)return false;
		return true;
	}
	public synchronized Predmet uzmi(char c)throws InterruptedException{
		while(nema(c))wait();
		Elem tek,pros=null;
		for(tek=prvi;tek!=null && tek.p.vrsta()!=c;tek=tek.sled)
			pros=tek;
		pros.sled=tek.sled;
		Vs-=tek.p.V();
		notifyAll();
		return tek.p;
	}
	

}
