import Predmeti.*;

public class Skladiste {
	private double ukV,maxV;
	private class Elem{
		public Predmet p;
		public Elem sled;
		public Elem(Predmet pp){ p=pp; sled=null; }
	}
	private Elem prvi,posl;
	
	public Skladiste(double v){ maxV=v; prvi=posl=null; }
	
	public synchronized void stavi(Predmet pp)throws InterruptedException{
		while(maxV<ukV+pp.V())wait();
		if(prvi==null) prvi=posl=new Elem(pp);
		else{
			posl.sled=new Elem(pp);
			posl=posl.sled;
		}
		ukV+=pp.V();
		notifyAll();
	}
	private boolean nema(char c){
		if(prvi==null)return true;
		for(Elem tek=prvi;tek!=null;tek=tek.sled)if(tek.p.vrsta()==c)return false;
		return true;
	}
	public synchronized Predmet uzmi(char c)throws InterruptedException{
		while(nema(c))wait();
		Elem tek,pros=null;
		for(tek=prvi;tek!=null && tek.p.vrsta()!=c;tek=tek.sled)
			pros=tek;
		pros.sled=tek.sled;
		ukV-=tek.p.V();
		notifyAll();
		return tek.p;
	}	
}
